%global project rally
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0

Name:             openstack-%{project}
Version:          0.7.0
Release:          6%{?dist}
Summary:          Benchmarking tool for OpenStack

License:          ASL 2.0
URL:              http://wiki.openstack.org/wiki/Rally
Source0:          https://tarballs.openstack.org/rally/rally-%{upstream_version}.tar.gz

Patch0001: 0001-Add-option-to-create-mistral-execution-from-workbook.patch
Patch0002: 0002-Add-nova.ListAndGetHypervisorUptime.patch
Patch0003: 0003-sys_call-hook-Open-subprocces-streams-in-preferred-e.patch
Patch0004: 0004-Reports-Significant-improvements-in-verification-rep.patch
Patch0005: 0005-Tests-Fix-functional-test_time_hook.patch
Patch0006: 0006-Plugins-Replace-instance_dd_test.sh-with-instance_te.patch
Patch0007: 0007-Add-nova.BootServerAndAddSecgroup.patch
Patch0008: 0008-Add-v3-role-create-usage.patch
Patch0009: 0009-Add-nova.getHypervisorStatistics.patch
Patch0010: 0010-Reports-Get-rid-of-Mako-in-reports-finally.patch
Patch0011: 0011-CLI-Fix-mentions-of-deprecated-command-rally-verify-.patch
Patch0012: 0012-Avoid-variables-overwrite-by-keystone-default-config.patch
Patch0013: 0013-Trivial-Fix-some-typos-in-rally.patch
Patch0014: 0014-Manila-Add-create_and_list_share-scenario-for-Manila.patch
Patch0015: 0015-Improve-debug-logging-level-in-Engine.patch
Patch0016: 0016-Add-CinderVolumes.list_types.patch
Patch0017: 0017-Fix-some-typos-in-release-note.patch
Patch0018: 0018-Don-t-attempt-to-escalate-rally-manage-privileges.patch
Patch0019: 0019-Benchmark-for-generate_random_name.patch
Patch0020: 0020-allow-passing-of-specific-volume-type.patch
Patch0021: 0021-Propose-Oleg-Bondarev-to-neutron-plugins-core.patch
Patch0022: 0022-Use-upper-constraints-for-tox-envs.patch
Patch0023: 0023-Increase-number-of-iterations-in-RallyProfile.genera.patch
Patch0024: 0024-Add-nova.ListAndSearchHypervisors-scenario.patch
Patch0025: 0025-Add-test-and-sample-to-CreateAndListNetworks.patch
Patch0026: 0026-Fix-a-typo-in-rally-verify-compare-msg.patch
Patch0027: 0027-Add-nova.ListAndGetHosts-scenario.patch
Patch0028: 0028-Fix-simple-typos-in-file-hypervisors.py.patch
Patch0029: 0029-Add-CinderVolumes.list_transfers.patch
Patch0030: 0030-Add-CinderVolumes.create_volume_and_update_readonly_.patch
Patch0031: 0031-Add-Quotas.nova_get.patch
Patch0032: 0032-Replace-six-iteration-methods-with-standard-ones.patch

BuildArch:        noarch

BuildRequires:    python2-devel
BuildRequires:    python-pbr
BuildRequires:    python-setuptools
# BuildRequires for oslo-config-generators
BuildRequires:    python-oslo-config >= 2:3.14.0
BuildRequires:    python-oslo-log >= 1.14.0
BuildRequires:    python-decorator
BuildRequires:    python-oslo-db >= 4.10.0
BuildRequires:    python-jsonschema
BuildRequires:    python-novaclient >= 2.29.0
BuildRequires:    python-keystoneclient
BuildRequires:    python-neutronclient >= 5.1.0
BuildRequires:    python-glanceclient >= 2.3.0
BuildRequires:    python-saharaclient >= 0.18.0
BuildRequires:    python-paramiko
BuildRequires:    python-sphinx
BuildRequires:    python-oslo-sphinx

Requires:         python-alembic >= 0.8.4
Requires:         python-boto
Requires:         python-decorator
Requires:         python-jinja2
Requires:         python-jsonschema
Requires:         python-netaddr
Requires:         python-oslo-config >= 2:3.14.0
Requires:         python-oslo-db >= 4.10.0
Requires:         python-oslo-i18n >= 2.1.0
Requires:         python-oslo-log >= 1.14.0
Requires:         python-oslo-serialization >= 1.19.0
Requires:         python-oslo-utils >= 1.4.0
Requires:         python-paramiko
Requires:         python-prettytable
Requires:         PyYAML
Requires:         python-designateclient
Requires:         python-gnocchiclient >= 2.2.0
Requires:         python-keystoneauth1 >= 2.10.0
Requires:         python-magnumclient >= 2.0.0
Requires:         python-manilaclient >= 1.10.0
Requires:         python-mistralclient >= 2.0.0
Requires:         python-muranoclient >= 0.8.2
Requires:         python-glanceclient >= 2.3.0
Requires:         python-keystoneclient
Requires:         python-manilaclient
Requires:         python-novaclient >= 2.29.0
Requires:         python-neutronclient >= 5.1.0
Requires:         python-cinderclient
Requires:         python-heatclient
Requires:         python-ceilometerclient
Requires:         python-ironicclient
Requires:         python-saharaclient >= 0.10.0
Requires:         python-swiftclient >= 2.2.0
Requires:         python-troveclient
Requires:         python-zaqarclient
Requires:         python-requests >= 2.5.2
Requires:         python-subunit
Requires:         python-sqlalchemy
Requires:         python-six >= 1.9.0
Requires:         python-sphinx

%description
Rally is a benchmarking tool capable of performing specific,
complex and reproducible test cases on real deployment scenarios.

%if 0%{?with_doc}
%package doc
Summary:    Documentation for OpenStack Rally

Requires:       %{name} = %{version}-%{release}

BuildRequires:  python-oslo-utils
BuildRequires:  python-prettytable
BuildRequires:  PyYAML
BuildRequires:  python-subunit
BuildRequires:  python-boto

%description doc
Rally is a benchmarking tool capable of performing specific,
complex and reproducible test cases on real deployment scenarios.

This package contains documentation files for Rally.
%endif

%prep
%setup -q -n %{project}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1

rm -rf {test-,}requirements.txt

%build
%{__python2} setup.py build

# for Documentation
%if 0%{?with_doc}
%{__python2} setup.py build_sphinx
%endif

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
mkdir -p %{buildroot}/%{_sysconfdir}/bash_completion.d
mv %{buildroot}/usr/etc/bash_completion.d/rally.bash_completion %{buildroot}/%{_sysconfdir}/bash_completion.d

# Generate tempest config
install -d -m 755 %{buildroot}%{_sysconfdir}/%{project}/
PYTHONPATH=. oslo-config-generator --config-file etc/rally/rally-config-generator.conf \
                      --output-file %{buildroot}%{_sysconfdir}/%{project}/rally.conf

# fix config permission
chmod 644 %{buildroot}%{_sysconfdir}/%{project}/rally.conf

# remove unnecessary files
rm -fr %{buildroot}%{python2_sitelib}/%{project}/deployment/engines/devstack
rm -fr %{buildroot}%{python2_sitelib}/%{project}/deployment/engines/lxc
rm -fr %{buildroot}%{python2_sitelib}/%{project}/deployment/serverprovider/providers/lxc

%files
%license LICENSE
%{python2_sitelib}/%{project}
%{python2_sitelib}/%{project}*.egg-info
%config(noreplace) %{_sysconfdir}/%{project}/%{project}.conf
%{_bindir}/%{project}
%{_bindir}/%{project}-manage
%{_sysconfdir}/bash_completion.d/rally.bash_completion

%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html
%endif

%changelog
* Mon Nov 07 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-6
- Replace six iteration methods with standard ones
- Add Quotas.nova_get The scenario list the quotas for nova
- Add CinderVolumes.create_volume_and_update_readonly_flag
- Add CinderVolumes.list_transfers

* Tue Nov 01 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-5
- Fix simple typos in file hypervisors.py
- Add nova.ListAndGetHosts scenario
- Fix a typo in 'rally verify compare' msg
- Add test and sample to CreateAndListNetworks
- Add nova.ListAndSearchHypervisors scenario
- Increase number of iterations in RallyProfile.generate_names_in_atomic
- Use upper-constraints for tox envs
- Propose Oleg Bondarev to neutron-plugins-core
- allow passing of specific volume type

* Fri Oct 28 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-4
- Benchmark for generate_random_name
- Don't attempt to escalate rally-manage privileges
- Fix some typos in release note
- Add CinderVolumes.list_types
- Improve debug logging level in Engine

* Tue Oct 25 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-3
- [Manila] Add create_and_list_share scenario for Manila
- [Trivial] Fix some typos in rally
- Avoid variables overwrite by keystone default config
- [CLI] Fix mentions of deprecated command `rally verify compare'
- [Reports] Get rid of Mako in reports, finally
- Add nova.getHypervisorStatistics
- Add v3 role create usage
- Add nova.BootServerAndAddSecgroup
- [Plugins] Replace instance_dd_test.sh with instance_test.sh

* Mon Oct 24 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-2
- [Tests] Fix functional test_time_hook
- [Reports] Significant improvements in verification report
- sys_call hook: Open subprocces streams in preferred encoding
- Add nova.ListAndGetHypervisorUptime
- Add option to create mistral execution from workbook

* Mon Oct 24 2016 Jon Schlueter <jschluet@redhat.com> 0.7.0-1
- Update to 0.7.0

* Fri Sep 16 2016 Haikel Guemar <hguemar@fedoraproject.org> 0.6.0-1
- Update to 0.6.0

